diff --git a/liboctave/array/fNDArray.cc b/liboctave/array/fNDArray.cc
--- a/liboctave/array/fNDArray.cc
+++ b/liboctave/array/fNDArray.cc
@@ -635,51 +635,59 @@ FloatNDArray::sumsq (int dim) const
 }
 
 FloatNDArray
-FloatNDArray::max (int dim) const
+FloatNDArray::max (int dim, bool includenan) const
 {
-  return do_mx_minmax_op<float> (*this, dim, mx_inline_max);
+  return do_mx_minmax_op<float> (*this, dim, mx_inline_max, includenan);
 }
 
 FloatNDArray
-FloatNDArray::max (Array<octave_idx_type>& idx_arg, int dim) const
+FloatNDArray::max (Array<octave_idx_type>& idx_arg,
+                   int dim, bool includenan) const
 {
-  return do_mx_minmax_op<float> (*this, idx_arg, dim, mx_inline_max);
+  return do_mx_minmax_op<float> (*this, idx_arg, dim, mx_inline_max,
+                                 includenan);
 }
 
 FloatNDArray
-FloatNDArray::min (int dim) const
+FloatNDArray::min (int dim, bool includenan) const
 {
-  return do_mx_minmax_op<float> (*this, dim, mx_inline_min);
+  return do_mx_minmax_op<float> (*this, dim, mx_inline_min, includenan);
 }
 
 FloatNDArray
-FloatNDArray::min (Array<octave_idx_type>& idx_arg, int dim) const
+FloatNDArray::min (Array<octave_idx_type>& idx_arg,
+                   int dim, bool includenan) const
 {
-  return do_mx_minmax_op<float> (*this, idx_arg, dim, mx_inline_min);
+  return do_mx_minmax_op<float> (*this, idx_arg, dim, mx_inline_min,
+                                 includenan);
 }
 
 FloatNDArray
-FloatNDArray::cummax (int dim) const
+FloatNDArray::cummax (int dim, bool includenan) const
 {
-  return do_mx_cumminmax_op<float> (*this, dim, mx_inline_cummax);
+  return do_mx_cumminmax_op<float> (*this, dim, mx_inline_cummax, includenan);
 }
 
 FloatNDArray
-FloatNDArray::cummax (Array<octave_idx_type>& idx_arg, int dim) const
+FloatNDArray::cummax (Array<octave_idx_type>& idx_arg,
+                      int dim, bool includenan) const
 {
-  return do_mx_cumminmax_op<float> (*this, idx_arg, dim, mx_inline_cummax);
+  return do_mx_cumminmax_op<float> (*this, idx_arg, dim, mx_inline_cummax,
+                                    includenan);
 }
 
 FloatNDArray
-FloatNDArray::cummin (int dim) const
+FloatNDArray::cummin (int dim, bool includenan) const
 {
-  return do_mx_cumminmax_op<float> (*this, dim, mx_inline_cummin);
+  return do_mx_cumminmax_op<float> (*this, dim, mx_inline_cummin, includenan);
 }
 
 FloatNDArray
-FloatNDArray::cummin (Array<octave_idx_type>& idx_arg, int dim) const
+FloatNDArray::cummin (Array<octave_idx_type>& idx_arg,
+                      int dim, bool includenan) const
 {
-  return do_mx_cumminmax_op<float> (*this, idx_arg, dim, mx_inline_cummin);
+  return do_mx_cumminmax_op<float> (*this, idx_arg, dim, mx_inline_cummin,
+                                    includenan);
 }
 
 FloatNDArray
diff --git a/liboctave/array/fNDArray.h b/liboctave/array/fNDArray.h
--- a/liboctave/array/fNDArray.h
+++ b/liboctave/array/fNDArray.h
@@ -99,15 +99,19 @@ public:
   charNDArray concat (const charNDArray& rb,
                       const Array<octave_idx_type>& ra_idx);
 
-  FloatNDArray max (int dim = -1) const;
-  FloatNDArray max (Array<octave_idx_type>& index, int dim = -1) const;
-  FloatNDArray min (int dim = -1) const;
-  FloatNDArray min (Array<octave_idx_type>& index, int dim = -1) const;
+  FloatNDArray max (int dim = -1, bool includenan = false) const;
+  FloatNDArray max (Array<octave_idx_type>& index,
+                    int dim = -1, bool includenan = false) const;
+  FloatNDArray min (int dim = -1, bool includenan = false) const;
+  FloatNDArray min (Array<octave_idx_type>& index,
+                    int dim = -1, bool includenan = false) const;
 
-  FloatNDArray cummax (int dim = -1) const;
-  FloatNDArray cummax (Array<octave_idx_type>& index, int dim = -1) const;
-  FloatNDArray cummin (int dim = -1) const;
-  FloatNDArray cummin (Array<octave_idx_type>& index, int dim = -1) const;
+  FloatNDArray cummax (int dim = -1, bool includenan = false) const;
+  FloatNDArray cummax (Array<octave_idx_type>& index,
+                       int dim = -1, bool includenan = false) const;
+  FloatNDArray cummin (int dim = -1, bool includenan = false) const;
+  FloatNDArray cummin (Array<octave_idx_type>& index,
+                       int dim = -1, bool includenan = false) const;
 
   FloatNDArray diff (octave_idx_type order = 1, int dim = -1) const;
 
diff --git a/liboctave/array/intNDArray.cc b/liboctave/array/intNDArray.cc
--- a/liboctave/array/intNDArray.cc
+++ b/liboctave/array/intNDArray.cc
@@ -239,58 +239,64 @@ intNDArray<T>::cumsum (int dim) const
 
 template <typename T>
 intNDArray<T>
-intNDArray<T>::max (int dim) const
+intNDArray<T>::max (int dim, bool includenan) const
 {
-  return do_mx_minmax_op<T> (*this, dim, mx_inline_max);
+  return do_mx_minmax_op<T> (*this, dim, mx_inline_max, includenan);
 }
 
 template <typename T>
 intNDArray<T>
-intNDArray<T>::max (Array<octave_idx_type>& idx_arg, int dim) const
+intNDArray<T>::max (Array<octave_idx_type>& idx_arg,
+                    int dim, bool includenan) const
 {
-  return do_mx_minmax_op<T> (*this, idx_arg, dim, mx_inline_max);
+  return do_mx_minmax_op<T> (*this, idx_arg, dim, mx_inline_max, includenan);
 }
 
 template <typename T>
 intNDArray<T>
-intNDArray<T>::min (int dim) const
+intNDArray<T>::min (int dim, bool includenan) const
 {
-  return do_mx_minmax_op<T> (*this, dim, mx_inline_min);
+  return do_mx_minmax_op<T> (*this, dim, mx_inline_min, includenan);
 }
 
 template <typename T>
 intNDArray<T>
-intNDArray<T>::min (Array<octave_idx_type>& idx_arg, int dim) const
+intNDArray<T>::min (Array<octave_idx_type>& idx_arg,
+                    int dim, bool includenan) const
 {
-  return do_mx_minmax_op<T> (*this, idx_arg, dim, mx_inline_min);
+  return do_mx_minmax_op<T> (*this, idx_arg, dim, mx_inline_min, includenan);
 }
 
 template <typename T>
 intNDArray<T>
-intNDArray<T>::cummax (int dim) const
+intNDArray<T>::cummax (int dim, bool includenan) const
 {
-  return do_mx_cumminmax_op<T> (*this, dim, mx_inline_cummax);
+  return do_mx_cumminmax_op<T> (*this, dim, mx_inline_cummax, includenan);
 }
 
 template <typename T>
 intNDArray<T>
-intNDArray<T>::cummax (Array<octave_idx_type>& idx_arg, int dim) const
+intNDArray<T>::cummax (Array<octave_idx_type>& idx_arg,
+                       int dim, bool includenan) const
 {
-  return do_mx_cumminmax_op<T> (*this, idx_arg, dim, mx_inline_cummax);
+  return do_mx_cumminmax_op<T> (*this, idx_arg, dim, mx_inline_cummax,
+                                includenan);
 }
 
 template <typename T>
 intNDArray<T>
-intNDArray<T>::cummin (int dim) const
+intNDArray<T>::cummin (int dim, bool includenan) const
 {
-  return do_mx_cumminmax_op<T> (*this, dim, mx_inline_cummin);
+  return do_mx_cumminmax_op<T> (*this, dim, mx_inline_cummin, includenan);
 }
 
 template <typename T>
 intNDArray<T>
-intNDArray<T>::cummin (Array<octave_idx_type>& idx_arg, int dim) const
+intNDArray<T>::cummin (Array<octave_idx_type>& idx_arg,
+                       int dim, bool includenan) const
 {
-  return do_mx_cumminmax_op<T> (*this, idx_arg, dim, mx_inline_cummin);
+  return do_mx_cumminmax_op<T> (*this, idx_arg, dim, mx_inline_cummin,
+                                includenan);
 }
 
 template <typename T>
diff --git a/liboctave/array/intNDArray.h b/liboctave/array/intNDArray.h
--- a/liboctave/array/intNDArray.h
+++ b/liboctave/array/intNDArray.h
@@ -81,15 +81,19 @@ public:
   boolNDArray all (int dim = -1) const;
   boolNDArray any (int dim = -1) const;
 
-  intNDArray max (int dim = -1) const;
-  intNDArray max (Array<octave_idx_type>& index, int dim = -1) const;
-  intNDArray min (int dim = -1) const;
-  intNDArray min (Array<octave_idx_type>& index, int dim = -1) const;
+  intNDArray max (int dim = -1, bool includenan = false) const;
+  intNDArray max (Array<octave_idx_type>& index,
+                  int dim = -1, bool includenan = false) const;
+  intNDArray min (int dim = -1, bool includenan = false) const;
+  intNDArray min (Array<octave_idx_type>& index,
+                  int dim = -1, bool includenan = false) const;
 
-  intNDArray cummax (int dim = -1) const;
-  intNDArray cummax (Array<octave_idx_type>& index, int dim = -1) const;
-  intNDArray cummin (int dim = -1) const;
-  intNDArray cummin (Array<octave_idx_type>& index, int dim = -1) const;
+  intNDArray cummax (int dim = -1, bool includenan = false) const;
+  intNDArray cummax (Array<octave_idx_type>& index,
+                     int dim = -1, bool includenan = false) const;
+  intNDArray cummin (int dim = -1, bool includenan = false) const;
+  intNDArray cummin (Array<octave_idx_type>& index,
+                     int dim = -1, bool includenan = false) const;
 
   intNDArray prod (int dim) const;
   intNDArray sum (int dim) const;
diff --git a/liboctave/numeric/lo-mappers.h b/liboctave/numeric/lo-mappers.h
--- a/liboctave/numeric/lo-mappers.h
+++ b/liboctave/numeric/lo-mappers.h
@@ -424,25 +424,25 @@ namespace octave
     inline std::complex<double>
     min (const std::complex<double>& x, const std::complex<double>& y)
     {
-      return abs (x) <= abs (y) ? x : (isnan (x) ? x : y);
+      return isnan (y) ? x : (x <= y ? x : y);
     }
 
     inline std::complex<float>
     min (const std::complex<float>& x, const std::complex<float>& y)
     {
-      return abs (x) <= abs (y) ? x : (isnan (x) ? x : y);
+      return isnan (y) ? x : (x <= y ? x : y);
     }
 
     inline std::complex<double>
     max (const std::complex<double>& x, const std::complex<double>& y)
     {
-      return abs (x) >= abs (y) ? x : (isnan (x) ? x : y);
+      return isnan (y) ? x : (x >= y ? x : y);
     }
 
     inline std::complex<float>
     max (const std::complex<float>& x, const std::complex<float>& y)
     {
-      return abs (x) >= abs (y) ? x : (isnan (x) ? x : y);
+      return isnan (y) ? x : (x >= y ? x : y);
     }
 
     template <typename T>
